﻿
// MFCApplication1Dlg.cpp: 实现文件
//

#include "pch.h"
#include "framework.h"
#include "MFCApplication1.h"
#include "MFCApplication1Dlg.h"
#include "afxdialogex.h"
#include "CvxText.h"
#include "BaseUtility.h"
#include "libpdf.h"

#if defined(GNUC)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored “-Wdeprecated-declarations”
#elif defined(_MSC_VER)
#pragma warning(disable : 4996)
#endif

#include <json/json.h>
#ifdef _DEBUG
#pragma comment(lib, "libpdfd.lib")
#else
#pragma comment(lib, "libpdf.lib")
#endif


#ifdef _DEBUG
#define new DEBUG_NEW
#endif

#define SAFETY_CLOSE_HANDLE( handle )									\
	if( NULL != handle )													\
{																		\
	CloseHandle( handle );												\
	handle = NULL;														\
}

#define SAFETY_EXIT_THREAD( hThread, Timeout )							\
	if( NULL != hThread )													\
{																		\
	if( WaitForSingleObject( hThread, Timeout ) == WAIT_TIMEOUT )		\
	TerminateThread( hThread, -1 );									\
	CloseHandle( hThread );												\
	hThread = NULL;														\
}


// 用于应用程序“关于”菜单项的 CAboutDlg 对话框

class CAboutDlg : public CDialogEx
{
public:
	CAboutDlg();

// 对话框数据
#ifdef AFX_DESIGN_TIME
	enum { IDD = IDD_ABOUTBOX };
#endif

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV 支持

// 实现
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialogEx(IDD_ABOUTBOX)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialogEx)
END_MESSAGE_MAP()


// CMFCApplication1Dlg 对话框


HANDLE _threadProcess = NULL;
DWORD WINAPI ProcessThread(void *param)
{
	CMFCApplication1Dlg* pWnd = (CMFCApplication1Dlg*)theApp.m_pMainWnd;
	//1.读txt列表
	//2.生成图像及图像对应的模板json
	Json::Value jsonArray(Json::arrayValue);
	Json::Value item;
	item["status"] = "1";
	item["url"] = "1";
	jsonArray.append(item);

	Json::Value itemRoot;
	itemRoot["status"] = 1;
	itemRoot["url"] = "1";
	
	Json::FastWriter writer;
	std::string strJson = writer.write(itemRoot);

	Json::Features features;
	Json::Reader re(features);
	Json::Value root;
	re.parse(strJson, root);
	if (root["status"].isInt() && root["status"].asInt() == 1)
	{
		string strUrl = root["url"].asString();
	}
	//3.图像合并成pdf

	//通知发送消息到窗口
	CString strErrorMsg = L"";
	strErrorMsg.Format(L"PDF生成完成!\r\n");
	SendMessage(pWnd->m_hWnd, WM_SHOWINFO, (WPARAM)strErrorMsg.GetBuffer(), 1);
	strErrorMsg.ReleaseBuffer();
	return 0L;
}

CMFCApplication1Dlg::CMFCApplication1Dlg(CWnd* pParent /*=nullptr*/)
	: CDialogEx(IDD_MFCAPPLICATION1_DIALOG, pParent)
	, m_strMsg(_T(""))
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CMFCApplication1Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
	DDX_Text(pDX, IDC_EDIT_MSG, m_strMsg);
}

BEGIN_MESSAGE_MAP(CMFCApplication1Dlg, CDialogEx)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDOK, &CMFCApplication1Dlg::OnBnClickedOk)
	ON_MESSAGE(WM_SHOWINFO, OnShowInfo)
	ON_BN_CLICKED(IDCANCEL, &CMFCApplication1Dlg::OnBnClickedCancel)
END_MESSAGE_MAP()


// CMFCApplication1Dlg 消息处理程序

BOOL CMFCApplication1Dlg::OnInitDialog()
{
	CDialogEx::OnInitDialog();

	// 将“关于...”菜单项添加到系统菜单中。

	// IDM_ABOUTBOX 必须在系统命令范围内。
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != nullptr)
	{
		BOOL bNameValid;
		CString strAboutMenu;
		bNameValid = strAboutMenu.LoadString(IDS_ABOUTBOX);
		ASSERT(bNameValid);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// 设置此对话框的图标。  当应用程序主窗口不是对话框时，框架将自动
	//  执行此操作
	SetIcon(m_hIcon, TRUE);			// 设置大图标
	SetIcon(m_hIcon, FALSE);		// 设置小图标

	// TODO: 在此添加额外的初始化代码

	return TRUE;  // 除非将焦点设置到控件，否则返回 TRUE
}

void CMFCApplication1Dlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialogEx::OnSysCommand(nID, lParam);
	}
}

// 如果向对话框添加最小化按钮，则需要下面的代码
//  来绘制该图标。  对于使用文档/视图模型的 MFC 应用程序，
//  这将由框架自动完成。

void CMFCApplication1Dlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // 用于绘制的设备上下文

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// 使图标在工作区矩形中居中
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// 绘制图标
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialogEx::OnPaint();
	}
}

//当用户拖动最小化窗口时系统调用此函数取得光标
//显示。
HCURSOR CMFCApplication1Dlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CMFCApplication1Dlg::OnBnClickedOk()
{
	GetDlgItem(IDOK)->EnableWindow(FALSE);

	SAFETY_EXIT_THREAD(_threadProcess, 100);
	_threadProcess = CreateThread(NULL, 0, ProcessThread, NULL, 0, NULL);

	std::vector<string> vecLines;
	for (size_t i = 0; i < 100; i++)
	{
		vecLines.push_back(ConvertGB2312toUTF8("寿1111111112222333"));
	}
	dataCollectionPaper(1,1000, 10, 100, false, vecLines);
	//CDialogEx::OnOK();
}

void CMFCApplication1Dlg::UpdateMsg(CString strMsg)
{
	m_strMsg += strMsg;
	UpdateData(FALSE);
}


LRESULT CMFCApplication1Dlg::OnShowInfo(WPARAM  wParam, LPARAM  lParam)
{
	char* p = (char*)wParam;
	CString str;
	str.Format(_T("%s"), p);
	m_strMsg += str;
	UpdateData(FALSE);

	if (lParam == 1)
	{
		GetDlgItem(IDOK)->EnableWindow(TRUE);
	}
	return 0;
}

void CMFCApplication1Dlg::OnBnClickedCancel()
{
	SAFETY_EXIT_THREAD(_threadProcess, 100);
	CDialogEx::OnCancel();
}
